/*
 * Copyright (c) 1987, 1988, 1989 Stanford University
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Stanford not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.  Stanford makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 *
 * STANFORD DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL STANFORD BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/* 
 * Unique Graphic object class identifiers
 * (must be in range 2000 <= ClassId <= 2999)
 */

#ifndef grclasses_h
#define grclasses_h

static const int _GRAPHIC	= 2004;
static const int _FULL_GRAPHIC	= 2005;
static const int _PICTURE	= 2006;
static const int _INSTANCE	= 2007;
static const int _ELLIPSE	= 2008;
static const int _FILLELLIPSE	= 2009;
static const int _CIRCLE	= 2010;
static const int _FILLCIRCLE	= 2011;
static const int _POINT		= 2012;
static const int _LINE		= 2013;
static const int _MULTILINE	= 2014;
static const int _RECT		= 2015;
static const int _FILLRECT	= 2016;
static const int _POLYGON	= 2017;
static const int _FILLPOLYGON	= 2018;
static const int _BSPLINE	= 2019;
static const int _CLOSEDBSPLINE	= 2020;
static const int _FILLBSPLINE	= 2021;
static const int _LABEL		= 2022;
static const int _PCOLOR	= 2023;
static const int _POINTOBJ	= 2025;
static const int _LINEOBJ	= 2026;
static const int _BOXOBJ	= 2027;
static const int _MULTILINEOBJ	= 2028;
static const int _FILLPOLYGONOBJ= 2029;
static const int _PPATTERN	= 2033;
static const int _PFONT		= 2034;
static const int _PBRUSH	= 2035;
static const int _RASTERRECT    = 2036;
static const int _STENCIL       = 2037;

#endif
